Codeforces Contest 1110 problem C Meaningless Operations——找区间内两个数的与和异或的最大gcd

本文主要是介绍Codeforces Contest 1110 problem C Meaningless Operations——找区间内两个数的与和异或的最大gcd,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

Can the greatest common divisor and bitwise operations have anything in common? It is time to answer this question.

Suppose you are given a positive integer a. You want to choose some integer b from 1 to a−1 inclusive in such a way that the greatest common divisor (GCD) of integers a⊕b and a&b is as large as possible. In other words, you’d like to compute the following function:

f(a)=max0<b<agcd(a⊕b,a&b).
Here ⊕ denotes the bitwise XOR operation, and & denotes the bitwise AND operation.

The greatest common divisor of two integers x and y is the largest integer g such that both x and y are divided by g without remainder.

You are given q integers a1,a2,…,aq. For each of these integers compute the largest possible value of the greatest common divisor (when b is chosen optimally).

Input
The first line contains an integer q (1≤q≤103) — the number of integers you need to compute the answer for.

After that q integers are given, one per line: a1,a2,…,aq (2≤ai≤225−1) — the integers you need to compute the answer for.

Output
For each integer, print the answer in the same order as the integers are given in input.

Example
inputCopy
3
2
3
5
outputCopy
3
1
7
Note
For the first integer the optimal choice is b=1, then a⊕b=3, a&b=0, and the greatest common divisor of 3 and 0 is 3.

For the second integer one optimal choice is b=2, then a⊕b=1, a&b=2, and the greatest common divisor of 1 and 2 is 1.

For the third integer the optimal choice is b=2, then a⊕b=7, a&b=0, and the greatest common divisor of 7 and 0 is 7.

题意:

给你一个数a,你要在1到a-1之间找一个数,使得gcd(a&b,a⊕b)最大。

题解:

数学的1500难度对我来说就相当于1700了,想了一会才想到怎么做。。首先第一种不是 2 k − 1 2^k-1 2k1的数,很明显可以从note里面看出来就是 2 k − 1 2^k-1 2k1,因为我们可以找到一个数b,使得b&a=0,b|a= 2 n − 1 2^n-1 2n1,那么就是这个数了,还有一种是找到他的最大因子。

#include<bits/stdc++.h>
using namespace std;
#define ll long long
const int N=1e5+5;
int p[N],np[N],cnt;
void init()
{for(ll i=2;i<N;i++){if(!np[i]){p[++cnt]=i;for(ll j=i*i;j<N;j+=i)np[j]=1;}}
}
int main()
{init();int q;scanf("%d",&q);while(q--){int a;scanf("%d",&a);int ret=1,cnt=0;while(ret<=a)ret*=2,cnt++;if(ret-1==a){int ans=a;for(int i=1;i<=cnt&&p[i]<=sqrt(a);i++){if(a%p[i]==0){ans=p[i];break;}}printf("%d\n",a/ans);}elseprintf("%d\n",ret-1);}return 0;
}

这篇关于Codeforces Contest 1110 problem C Meaningless Operations——找区间内两个数的与和异或的最大gcd的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/881243

相关文章

csu 1446 Problem J Modified LCS (扩展欧几里得算法的简单应用)

这是一道扩展欧几里得算法的简单应用题,这题是在湖南多校训练赛中队友ac的一道题,在比赛之后请教了队友,然后自己把它a掉 这也是自己独自做扩展欧几里得算法的题目 题意:把题意转变下就变成了:求d1*x - d2*y = f2 - f1的解,很明显用exgcd来解 下面介绍一下exgcd的一些知识点:求ax + by = c的解 一、首先求ax + by = gcd(a,b)的解 这个

hdu 1754 I Hate It(线段树,单点更新,区间最值)

题意是求一个线段中的最大数。 线段树的模板题,试用了一下交大的模板。效率有点略低。 代码: #include <stdio.h>#include <string.h>#define TREE_SIZE (1 << (20))//const int TREE_SIZE = 200000 + 10;int max(int a, int b){return a > b ? a :

uva 10025 The ? 1 ? 2 ? ... ? n = k problem(数学)

题意是    ?  1  ?  2  ?  ...  ?  n = k 式子中给k,? 处可以填 + 也可以填 - ,问最小满足条件的n。 e.g k = 12  - 1 + 2 + 3 + 4 + 5 + 6 - 7 = 12 with n = 7。 先给证明,令 S(n) = 1 + 2 + 3 + 4 + 5 + .... + n 暴搜n,搜出当 S(n) >=

poj 3723 kruscal,反边取最大生成树。

题意: 需要征募女兵N人,男兵M人。 每征募一个人需要花费10000美元,但是如果已经招募的人中有一些关系亲密的人,那么可以少花一些钱。 给出若干的男女之间的1~9999之间的亲密关系度,征募某个人的费用是10000 - (已经征募的人中和自己的亲密度的最大值)。 要求通过适当的招募顺序使得征募所有人的费用最小。 解析: 先设想无向图,在征募某个人a时,如果使用了a和b之间的关系

poj 3258 二分最小值最大

题意: 有一些石头排成一条线,第一个和最后一个不能去掉。 其余的共可以去掉m块,要使去掉后石头间距的最小值最大。 解析: 二分石头,最小值最大。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <c

poj 2175 最小费用最大流TLE

题意: 一条街上有n个大楼,坐标为xi,yi,bi个人在里面工作。 然后防空洞的坐标为pj,qj,可以容纳cj个人。 从大楼i中的人到防空洞j去避难所需的时间为 abs(xi - pi) + (yi - qi) + 1。 现在设计了一个避难计划,指定从大楼i到防空洞j避难的人数 eij。 判断如果按照原计划进行,所有人避难所用的时间总和是不是最小的。 若是,输出“OPETIMAL",若

poj 2135 有流量限制的最小费用最大流

题意: 农场里有n块地,其中约翰的家在1号地,二n号地有个很大的仓库。 农场有M条道路(双向),道路i连接着ai号地和bi号地,长度为ci。 约翰希望按照从家里出发,经过若干块地后到达仓库,然后再返回家中的顺序带朋友参观。 如果要求往返不能经过同一条路两次,求参观路线总长度的最小值。 解析: 如果只考虑去或者回的情况,问题只不过是无向图中两点之间的最短路问题。 但是现在要去要回

poj 2594 二分图最大独立集

题意: 求一张图的最大独立集,这题不同的地方在于,间接相邻的点也可以有一条边,所以用floyd来把间接相邻的边也连起来。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <sta

poj 3422 有流量限制的最小费用流 反用求最大 + 拆点

题意: 给一个n*n(50 * 50) 的数字迷宫,从左上点开始走,走到右下点。 每次只能往右移一格,或者往下移一格。 每个格子,第一次到达时可以获得格子对应的数字作为奖励,再次到达则没有奖励。 问走k次这个迷宫,最大能获得多少奖励。 解析: 拆点,拿样例来说明: 3 2 1 2 3 0 2 1 1 4 2 3*3的数字迷宫,走两次最大能获得多少奖励。 将每个点拆成两个

poj 3692 二分图最大独立集

题意: 幼儿园里,有G个女生和B个男生。 他们中间有女生和女生认识,男生男生认识,也有男生和女生认识的。 现在要选出一些人,使得这里面的人都认识,问最多能选多少人。 解析: 反过来建边,将不认识的男生和女生相连,然后求一个二分图的最大独立集就行了。 下图很直观: 点击打开链接 原图: 现图: 、 代码: #pragma comment(